using System;
using System.Collections;

namespace _3DEngine
{

	public class CoordinateSystem : ITransformable
	{

		private Matrix transformation;
		private ArrayList transformableList;

		public CoordinateSystem()
		{
			transformation = Matrix.CreateIdentityMatrix();
			transformableList = new ArrayList();
		}

		public void AddTransformable(ITransformable transformable) 
		{
			transformableList.Add(transformable);
		}

		public void ChangeTransformation(Matrix transformation) 
		{
			this.transformation = transformation;
		}

		public void Transform(Matrix transformation) 
		{
			IEnumerator enumerator = transformableList.GetEnumerator();
			transformation = transformation.Mult(this.transformation);
			while(enumerator.MoveNext()) 
			{
				ITransformable transformable = (ITransformable)enumerator.Current;
				transformable.Transform(transformation);
			}
		}

	}

}
