using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using PlanetSystem;

namespace FunctionPlot
{

	public class FunctionPlotForm : System.Windows.Forms.Form
	{

		private System.ComponentModel.Container components = null;

		private Calculation calculator;

		private Result[] result;

		public FunctionPlotForm()
		{
			InitializeComponent();
			calculator = new Calculation();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		private void InitializeComponent()
		{
			// 
			// FunctionPlotForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1008, 182);
			this.Name = "FunctionPlotForm";
			this.Text = "Form1";
			this.Paint += new System.Windows.Forms.PaintEventHandler(this.FunctionPlotForm_Paint);

		}
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new FunctionPlotForm());
		}

		private void FunctionPlotForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if(result == null) 
			{
				result = calculator.Calculate();
				CounterView cw = new CounterView(result[0].GetAddSubCount(), result[0].GetMulDivCount(), result[0].GetTrigCount(), result[0].GetSqrtCount());
				cw.Show();
			}
			Pen red = new Pen(Color.Red);
			Pen blue = new Pen(Color.Blue);
			for(int x=0; x<result.Length-1; x++) 
			{
				Pen pen;
				if(result[x].IsVisible()) 
				{
					pen = red;
				}
				else 
				{
					pen = blue;
				}
				e.Graphics.DrawLine(pen, x, 90-(float)(result[x].GetAngle()), x+1, 90-(float)(result[x+1].GetAngle()));
			}

			e.Graphics.DrawLine(new Pen(Color.Black), 0, 90, result.Length, 90);

		}

	}
}
